import { UseFormMethods, FieldValues, FieldValuesFromControl, FieldValuesFromFieldErrors, FieldName, FieldErrors, MultipleFieldErrors, Message, ValidationOptions, Control } from './form';
import { Assign } from './utils';
import * as React from 'react';
export declare type FormProviderProps<TFieldValues extends FieldValues = FieldValues> = {
    children: React.ReactNode;
} & UseFormMethods<TFieldValues>;
declare type AsProps<TAs> = TAs extends undefined ? {} : TAs extends React.ReactElement ? Record<string, any> : TAs extends React.ComponentType<infer P> ? P : TAs extends keyof JSX.IntrinsicElements ? JSX.IntrinsicElements[TAs] : never;
export declare type ControllerProps<TAs extends React.ReactElement | React.ComponentType<any> | keyof JSX.IntrinsicElements, TControl extends Control = Control> = Assign<{
    name: FieldName<FieldValuesFromControl<TControl>>;
    as?: TAs;
    rules?: ValidationOptions;
    onFocus?: () => void;
    onChangeName?: string;
    onBlurName?: string;
    valueName?: string;
    defaultValue?: unknown;
    control?: TControl;
    render?: (data: {
        onChange: (...event: any[]) => void;
        onBlur: () => void;
        value: any;
    }) => React.ReactElement;
}, AsProps<TAs>>;
export declare type ErrorMessageProps<TFieldErrors extends FieldErrors, TAs extends undefined | React.ReactElement | React.ComponentType<any> | keyof JSX.IntrinsicElements = undefined> = Assign<{
    as?: TAs;
    errors?: TFieldErrors;
    name: FieldName<FieldValuesFromFieldErrors<TFieldErrors>>;
    message?: Message;
    render?: (data: {
        message: Message;
        messages?: MultipleFieldErrors;
    }) => React.ReactNode;
}, AsProps<TAs>>;
export {};
